Codeforces Round #385 (Div. 1) C. Hongcow Buys a Deck of Cards

地址:http://codeforces.com/problemset/problem/744/C

题目:

C. Hongcow Buys a Deck of Cards
time limit per test
2 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

One day, Hongcow goes to the store and sees a brand new deck of n special cards. Each individual card is either red or blue. He decides he wants to buy them immediately. To do this, he needs to play a game with the owner of the store.

This game takes some number of turns to complete. On a turn, Hongcow may do one of two things:

  • Collect tokens. Hongcow collects 1 red token and 1 blue token by choosing this option (thus, 2 tokens in total per one operation).
  • Buy a card. Hongcow chooses some card and spends tokens to purchase it as specified below.

The i-th card requires ri red resources and bi blue resources. Suppose Hongcow currently has A red cards and B blue cards. Then, the i-th card will require Hongcow to spend max(ri - A, 0) red tokens, and max(bi - B, 0) blue tokens. Note, only tokens disappear, but the cards stay with Hongcow forever. Each card can be bought only once.

Given a description of the cards and their costs determine the minimum number of turns Hongcow needs to purchase all cards.

Input

The first line of input will contain a single integer n (1 ≤ n ≤ 16).

The next n lines of input will contain three tokens ciri and bici will be 'R' or 'B', denoting the color of the card as red or blue. ri will be an integer denoting the amount of red resources required to obtain the card, and bi will be an integer denoting the amount of blue resources required to obtain the card (0 ≤ ri, bi ≤ 107).

Output

Output a single integer, denoting the minimum number of turns needed to acquire all the cards.

Examples
input
3
R 0 1
B 1 0
R 1 1
output
4
input
3
R 3 0
R 2 0
R 1 0
output
6
Note

For the first sample, Hongcow's four moves are as follows:

  1. Collect tokens
  2. Buy card 1
  3. Buy card 2
  4. Buy card 3
Note, at the fourth step, Hongcow is able to buy card 3 because Hongcow already has one red and one blue card, so we don't need to collect tokens.

For the second sample, one optimal strategy is as follows:

  1. Collect tokens
  2. Collect tokens
  3. Buy card 2
  4. Collect tokens
  5. Buy card 3
  6. Buy card 1
At the fifth step, even though Hongcow has a red token, Hongcow doesn't actually need to spend it, since Hongcow has a red card already.
思路:dp好题!(恩,也就意味着我不会)
  看到16很容想到枚举买卡片的状态,然后就是状态间的相互转移了,
  dp[i][j]的意义很重要,dp[i][j]表示在卡片状态i下,省下j张红色代币时最多省下蓝色代币的数量。
  状态转移方程具体见代码吧,最后答案枚举dp[(1<<n)-1][j]即可。
  还有dp数组必须初始化为负无穷
 1 #include <bits/stdc++.h>
 2 
 3 using namespace std;
 4 
 5 #define MP make_pair
 6 #define PB push_back
 7 typedef long long LL;
 8 typedef pair<int,int> PII;
 9 const double eps=1e-8;
10 const double pi=acos(-1.0);
11 const int K=1e6+7;
12 const int mod=1e9+7;
13 
14 
15 int n,sz,sumr,sumb,r[20],b[20],dp[1<<16][150],srr[20],sbb[20];
16 char col[20];
17 int main(void)
18 {
19     cin>>n;
20     sz=1<<n;
21     for(int i=0;i<n;i++)
22         scanf("%s%d%d",col+i,r+i,b+i),sumr+=r[i],sumb+=b[i];
23     memset(dp,0xef,sizeof(dp));
24     dp[0][0]=0;
25     for(int i=0;i<sz;i++)
26     {
27         int sr,sb;
28         sr=sb=0;
29         for(int j=0;j<n;j++)
30         if(i&(1<<j))
31             col[j]=='R'?sr++:sb++;
32         for(int j=0;j<n;j++)
33         if(!(i&(1<<j)))
34             srr[j]=min(sr,r[j]),sbb[j]=min(sb,b[j]);
35         for(int j=0;j<n;j++)
36         if(!(i&(1<<j)))
37             for(int k=0;k<=120;k++)
38             dp[i|(1<<j)][k+srr[j]]=max(dp[i|(1<<j)][k+srr[j]],dp[i][k]+sbb[j]);
39     }
40     int ans=2e9;
41     for(int i=0;i<=120;i++)
42         ans=min(max(sumr-i,sumb-dp[sz-1][i]),ans);
43     printf("%d
",ans+n);
44     return 0;
45 }

 

原文地址:https://www.cnblogs.com/weeping/p/6368117.html